﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace SolSoft.DataBinding.WpfDemo
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			//set up bindings
			MainViewModel forNaming = null; //get rid of if you use nameof (for max compatibility I am using only C# 5 in this demo)
			textBoxValue1.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(() => forNaming.Value1));
			textBoxValue2.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(() => forNaming.Value2));
			textBoxValue3.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(() => forNaming.Value3));
			textBoxValue4.SetBinding(TextBox.TextProperty, ObjectNamingExtensions.GetName(() => forNaming.Value4));
			textBoxValueTotal.SetBinding(TextBox.TextProperty, new Binding
			{
				Path = new PropertyPath(ObjectNamingExtensions.GetName(() => forNaming.TotalValue)),
				Mode = BindingMode.OneWay
			});

			gridValues.SetBinding(Grid.IsEnabledProperty, ObjectNamingExtensions.GetName(() => forNaming.IsEnabled));
			buttonGenerate.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(() => forNaming.GenerateValuesCommand));
			buttonClear.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(() => forNaming.ClearValuesCommand));
			buttonQuit.SetBinding(Button.CommandProperty, ObjectNamingExtensions.GetName(() => forNaming.QuitCommand));

			gridProgress.SetBinding(Grid.VisibilityProperty, new Binding
			{
				Path = new PropertyPath(ObjectNamingExtensions.GetName(() => forNaming.IsBusy)),
				Converter = new BooleanToVisibilityConverter()
			});
		}

		public MainViewModel ViewModel
		{
			get
			{
				return DataContext as MainViewModel;
			}
			set
			{
				DataContext = value;
			}
		}
	}
}
