﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SolSoft.DataBinding
{
	/// <summary>
	/// Represents a property that has a name and value.  
	/// </summary>
	/// <typeparam name="TValue">Type of the property value</typeparam>
	public interface IProperty<TValue> : INotifyValueChanged
	{
		/// <summary>
		/// Gets the name of this property
		/// </summary>
		string Name
		{
			get;
		}

		/// <summary>
		/// Gets the current value of this property
		/// </summary>
		TValue Value
		{
			get;
		}
	}
}
