﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;

namespace SolSoft.DataBinding
{
	/// <summary>
	/// Interface representing an object that can be told to raise <see cref="INotifyPropertyChanged.PropertyChanged"/> 
	/// </summary>
	public interface IRaisePropertyChanged : INotifyPropertyChanged
	{
		/// <summary>
		/// Raises the <see cref="INotifyPropertyChanged.PropertyChanged"/> event on this object.  It is recommended that this method be explicitly implemented
		/// </summary>
		/// <param name="propertyName">Name of the property that has changed</param>
		[SuppressMessage("Microsoft.Design", "CA1030:UseEventsWhereAppropriate")]
		void RaisePropertyChanged(string propertyName);
	}
}
